package pdf

// Encoding represents one of the character set encodings supported by the PDF format.
type Encoding uint8

// Available builtin encodings supported by PDF documents.
const (
	StandardEncoding Encoding = iota
	MacRomanEncoding
	WinAnsiEncoding
	PDFDocEncoding
	MacExpertEncoding
	SymbolEncoding
	ZapfDingbatsEncoding
)

// String returns a string representation of the encoding.
func (e Encoding) String() string {
	switch e {
	case StandardEncoding:
		return "StandardEncoding"
	case MacRomanEncoding:
		return "MacRomanEncoding"
	case WinAnsiEncoding:
		return "WinAnsiEncoding"
	case PDFDocEncoding:
		return "PDFDocEncoding"
	case MacExpertEncoding:
		return "MacExpertEncoding"
	case SymbolEncoding:
		return "SymbolEncoding"
	case ZapfDingbatsEncoding:
		return "ZapfDingbatsEncoding"
	}

	panic("Unknown encoding value")
}

// EncodeFromUTF8 converts text from the standard UTF-8 encoding used by strings
// to the specified encoding.
//
// If characters are found in the string that cannot be mapped into the
// specified encoding, those characters will be replaced with a question mark.
// The return value ok will be false.
func (e Encoding) encodeFromUTF8(text string) (data []byte, ok bool) {
	// Lookup the correct map from rune to bytes for the encoding
	emap := e.Map()

	// Translate the runes, one-by-one, to the specified encoding
	ret := make([]byte, 0, len(text))
	success := true
	for _, v := range text {
		if r, ok := emap[v]; ok {
			ret = append(ret, r)
		} else {
			ret = append(ret, '?')
			success = false
		}
	}

	return ret, success
}

// Map returns a map that can be used to translate runes into bytes that
// match the encoding.
func (e Encoding) Map() map[rune]byte {
	switch e {
	case StandardEncoding:
		return mapStandardEncoding
	case MacRomanEncoding:
		return mapMacRomanEncoding
	case WinAnsiEncoding:
		return mapWinAnsiEncoding
	case PDFDocEncoding:
		return mapPDFDocEncoding
	case MacExpertEncoding:
		// The specification does not include a separate table for the
		// MacExpertEncoding.  The following is probably not correct.
		return mapMacRomanEncoding
	case SymbolEncoding:
		return mapSymbolEncoding
	case ZapfDingbatsEncoding:
		return mapZapfDingbatsEncoding
	}

	panic("Unknown encoding value")
}

var mapStandardEncoding = map[rune]byte{
	'A': 65,
	'Æ': 225,
	'B': 66,
	'C': 67,
	'D': 68,
	'E': 69,
	'F': 70,
	'G': 71,
	'H': 72,
	'I': 73,
	'J': 74,
	'K': 75,
	'L': 76,
	'Ł': 232,
	'M': 77,
	'N': 78,
	'O': 79,
	'Œ': 234,
	'Ø': 233,
	'P': 80,
	'Q': 81,
	'R': 82,
	'S': 83,
	'T': 84,
	'U': 85,
	'V': 86,
	'W': 87,
	'X': 88,
	'Y': 89,
	'Z': 90,
	'a': 97,
	// acute ' ́':194,
	'æ':  241,
	'&':  38,
	'^':  94,
	'~':  126,
	'*':  42,
	'@':  64,
	'b':  98,
	'\\': 92,
	'|':  124,
	'{':  123,
	'}':  125,
	'[':  91,
	']':  93,
	// breve ' ̆':198,
	'•': 183,
	'c': 99,
	'ˇ': 207,
	// cedilla ' ̧':203,
	'¢': 162,
	'ˆ': 195,
	':': 58,
	',': 44,
	'¤': 168,
	'd': 100,
	'†': 178,
	'‡': 179,
	// diresis ' ̈':200,
	'$': 36,
	// dotaccent ' ̇':199,
	'ı':  245,
	'e':  101,
	'8':  56,
	8230: 188,
	'—':  208,
	'–':  177,
	'=':  61,
	'!':  33,
	'¡':  161,
	'f':  102,
	// fi 'fi':174,
	'5': 53,
	// fl 'fl':175,
	'ƒ': 166,
	'4': 52,
	'⁄': 164,
	'g': 103,
	'ß': 251,
	'`': 193,
	'>': 62,
	'«': 171,
	'»': 187,
	'‹': 172,
	'›': 173,
	'h': 104,
	// hungarumlaut ' ̋':205,
	'-': 45,
	'i': 105,
	'j': 106,
	'k': 107,
	'l': 108,
	'<': 60,
	'ł': 248,
	'm': 109,
	// macron ' ̄':197,
	'n': 110,
	'9': 57,
	'#': 35,
	'o': 111,
	'œ': 250,
	// ogonek ' ̨':206,
	'1':  49,
	170:  227,
	186:  235,
	'ø':  249,
	'p':  112,
	'¶':  182,
	'(':  40,
	')':  41,
	'%':  37,
	'.':  46,
	'·':  180,
	'‰':  189,
	'+':  43,
	'q':  113,
	'?':  63,
	'¿':  191,
	'"':  34,
	'„':  185,
	8220: 170,
	8221: 186,
	8216: 96,
	8217: 39,
	'‚':  184,
	'\'': 169,
	'r':  114,
	// ring ' ̊':202,
	's': 115,
	'§': 167,
	';': 59,
	'7': 55,
	'6': 54,
	'/': 47,
	' ': 32,
	'£': 163,
	't': 116,
	'3': 51,
	// tilde :196,
	'2': 50,
	'u': 117,
	'_': 95,
	'v': 118,
	'w': 119,
	'x': 120,
	'y': 121,
	'¥': 165,
	'z': 122,
	'0': 48,
}

var mapMacRomanEncoding = map[rune]byte{
	'A': 65,
	'Æ': 174,
	'Á': 231,
	'Â': 229,
	'Ä': 128,
	'À': 203,
	'Å': 129,
	'Ã': 204,
	'B': 66,
	'C': 67,
	'Ç': 130,
	'D': 68,
	'E': 69,
	'É': 131,
	'Ê': 230,
	'Ë': 232,
	'È': 233,
	'F': 70,
	'G': 71,
	'H': 72,
	'I': 73,
	'Í': 234,
	'Î': 235,
	'Ï': 236,
	'Ì': 237,
	'J': 74,
	'K': 75,
	'L': 76,
	'M': 77,
	'N': 78,
	'Ñ': 132,
	'O': 79,
	'Œ': 206,
	'Ó': 238,
	'Ô': 239,
	'Ö': 133,
	'Ò': 241,
	'Ø': 175,
	'Õ': 205,
	'P': 80,
	'Q': 81,
	'R': 82,
	'S': 83,
	'T': 84,
	'U': 85,
	'Ú': 242,
	'Û': 243,
	'Ü': 134,
	'Ù': 244,
	'V': 86,
	'W': 87,
	'X': 88,
	'Y': 89,
	'Ÿ': 217,
	'Z': 90,
	'a': 97,
	'á': 135,
	'â': 137,
	// acute ' ́':171,
	'ä':  138,
	'æ':  190,
	'à':  136,
	'&':  38,
	'å':  140,
	'^':  94,
	'~':  126,
	'*':  42,
	'@':  64,
	'ã':  139,
	'b':  98,
	'\\': 92,
	'|':  124,
	'{':  123,
	'}':  125,
	'[':  91,
	']':  93,
	// breve ' ̆':249,
	'•': 165,
	'c': 99,
	'ˇ': 255,
	'ç': 141,
	// cedilla ' ̧':252,
	'¢': 162,
	'ˆ': 246,
	':': 58,
	',': 44,
	'©': 169,
	'¤': 219,
	'd': 100,
	'†': 160,
	'‡': 224,
	'°': 161,
	// dieresis ' ̈':172,
	'÷': 214,
	'$': 36,
	// dotaccent ' ̇':250,
	'ı':  245,
	'e':  101,
	'é':  142,
	'ê':  144,
	'ë':  145,
	'è':  143,
	'8':  56,
	8230: 201,
	'—':  209,
	'–':  208,
	'=':  61,
	'!':  33,
	'¡':  193,
	'f':  102,
	// fi:222,
	'5': 53,
	// fl:223,
	'ƒ': 196,
	'4': 52,
	'⁄': 218,
	'g': 103,
	'ß': 167,
	'`': 96,
	'>': 62,
	'«': 199,
	'»': 200,
	'‹': 220,
	'›': 221,
	'h': 104,
	// hungarumlaut:253,
	'-': 45,
	'i': 105,
	'í': 146,
	'î': 148,
	'ï': 149,
	'ì': 147,
	'j': 106,
	'k': 107,
	'l': 108,
	'<': 60,
	'¬': 194,
	'm': 109,
	// macron ' ̄':248,
	'μ': 181,
	'n': 110,
	'9': 57,
	'ñ': 150,
	'#': 35,
	'o': 111,
	'ó': 151,
	'ô': 153,
	'ö': 154,
	'œ': 207,
	// ogonek ' ̨':254,
	'ò':  152,
	'1':  49,
	170:  187,
	186:  188,
	'ø':  191,
	'õ':  155,
	'p':  112,
	'¶':  166,
	'(':  40,
	')':  41,
	'%':  37,
	'.':  46,
	'·':  225,
	'‰':  228,
	'+':  43,
	'±':  177,
	'q':  113,
	'?':  63,
	'¿':  192,
	'"':  34,
	'„':  227,
	'“':  210,
	'”':  211,
	'‘':  212,
	'’':  213,
	'‚':  226,
	'\'': 39,
	'r':  114,
	'®':  168,
	// ring ' ̊':251,
	's': 115,
	'§': 164,
	';': 59,
	'7': 55,
	'6': 54,
	'/': 47,
	' ': 32,
	'£': 163,
	't': 116,
	'3': 51,
	// tilde :247,
	8482: 170,
	'2':  50,
	'u':  117,
	'ú':  156,
	'û':  158,
	'ü':  159,
	'ù':  157,
	'_':  95,
	'v':  118,
	'w':  119,
	'x':  120,
	'y':  121,
	'ÿ':  216,
	'¥':  180,
	'z':  122,
	'0':  48,
}

var mapWinAnsiEncoding = map[rune]byte{
	'A': 65,
	'Æ': 198,
	'Á': 193,
	'Â': 194,
	'Ä': 196,
	'À': 192,
	'Å': 197,
	'Ã': 195,
	'B': 66,
	'C': 67,
	'Ç': 199,
	'D': 68,
	'E': 69,
	'É': 201,
	'Ê': 202,
	'Ë': 203,
	'È': 200,
	'Ð': 208,
	'€': 128,
	'F': 70,
	'G': 71,
	'H': 72,
	'I': 73,
	'Í': 205,
	'Î': 206,
	'Ï': 207,
	'Ì': 204,
	'J': 74,
	'K': 75,
	'L': 76,
	'M': 77,
	'N': 78,
	'Ñ': 209,
	'O': 79,
	'Œ': 140,
	'Ó': 211,
	'Ô': 212,
	'Ö': 214,
	'Ò': 210,
	'Ø': 216,
	'Õ': 213,
	'P': 80,
	'Q': 81,
	'R': 82,
	'S': 83,
	'Š': 138,
	'T': 84,
	'Þ': 222,
	'U': 85,
	'Ú': 218,
	'Û': 219,
	'Ü': 220,
	'Ù': 217,
	'V': 86,
	'W': 87,
	'X': 88,
	'Y': 89,
	'Ý': 221,
	'Ÿ': 159,
	'Z': 90,
	'Ž': 142,
	'a': 97,
	'á': 225,
	'â': 226,
	// acute ' ́':180,
	'ä':  228,
	'æ':  230,
	'à':  224,
	'&':  38,
	'å':  229,
	'^':  94,
	'~':  126,
	'*':  42,
	'@':  64,
	'ã':  227,
	'b':  98,
	'\\': 92,
	'|':  124,
	'{':  123,
	'}':  125,
	'[':  91,
	']':  93,
	'¦':  166,
	'•':  149,
	'c':  99,
	'ç':  231,
	// cedilla ' ̧':184,
	'¢': 162,
	'ˆ': 136,
	':': 58,
	',': 44,
	'©': 169,
	'¤': 164,
	'd': 100,
	'†': 134,
	'‡': 135,
	'°': 176,
	// dieresis ' ̈':168,
	'÷':  247,
	'$':  36,
	'e':  101,
	'é':  233,
	'ê':  234,
	'ë':  235,
	'è':  232,
	'8':  56,
	8230: 133,
	'—':  151,
	'–':  150,
	'=':  61,
	'ð':  240,
	'!':  33,
	'¡':  161,
	'f':  102,
	// fi:,
	'5': 53,
	// fl:,
	'ƒ': 131,
	'4': 52,
	'g': 103,
	'ß': 223,
	'`': 96,
	'>': 62,
	'«': 171,
	'»': 187,
	'‹': 139,
	'›': 155,
	'h': 104,
	'-': 45,
	'i': 105,
	'í': 237,
	'î': 238,
	'ï': 239,
	'ì': 236,
	'j': 106,
	'k': 107,
	'l': 108,
	'<': 60,
	'¬': 172,
	'm': 109,
	// macron ' ̄':175,
	'μ': 181,
	'×': 215,
	'n': 110,
	'9': 57,
	'ñ': 241,
	'#': 35,
	'o': 111,
	'ó': 243,
	'ô': 244,
	'ö': 246,
	'œ': 156,
	'ò': 242,
	'1': 49,
	189: 189,
	188: 188,
	// superscript 1:185,
	170:  170,
	186:  186,
	'ø':  248,
	'õ':  245,
	'p':  112,
	'¶':  182,
	'(':  40,
	')':  41,
	'%':  37,
	'.':  46,
	'·':  183,
	'‰':  137,
	'+':  43,
	'±':  177,
	'q':  113,
	'?':  63,
	'¿':  191,
	'"':  34,
	'„':  132,
	'“':  147,
	'”':  148,
	'‘':  145,
	'’':  146,
	'‚':  130,
	'\'': 39,
	'r':  114,
	'®':  174,
	's':  115,
	'š':  154,
	'§':  167,
	';':  59,
	'7':  55,
	'6':  54,
	'/':  47,
	' ':  32,
	'£':  163,
	't':  116,
	'þ':  254,
	'3':  51,
	190:  190,
	179:  179,
	// tilde :152,
	8482: 153,
	'2':  50,
	178:  178,
	'u':  117,
	'ú':  250,
	'û':  251,
	'ü':  252,
	'ù':  249,
	'_':  95,
	'v':  118,
	'w':  119,
	'x':  120,
	'y':  121,
	'ý':  253,
	'ÿ':  255,
	'¥':  165,
	'z':  122,
	'ž':  158,
	'0':  48,
}

var mapPDFDocEncoding = map[rune]byte{
	'A': 65,
	'Æ': 198,
	'Á': 193,
	'Â': 194,
	'Ä': 196,
	'À': 192,
	'Å': 197,
	'Ã': 195,
	'B': 66,
	'C': 67,
	'Ç': 199,
	'D': 68,
	'E': 69,
	'É': 201,
	'Ê': 202,
	'Ë': 203,
	'È': 200,
	'Ð': 208,
	'€': 160,
	'F': 70,
	'G': 71,
	'H': 72,
	'I': 73,
	'Í': 205,
	'Î': 206,
	'Ï': 207,
	'Ì': 204,
	'J': 74,
	'K': 75,
	'L': 76,
	'Ł': 149,
	'M': 77,
	'N': 78,
	'Ñ': 209,
	'O': 79,
	'Œ': 150,
	'Ó': 211,
	'Ô': 212,
	'Ö': 214,
	'Ò': 210,
	'Ø': 216,
	'Õ': 213,
	'P': 80,
	'Q': 81,
	'R': 82,
	'S': 83,
	'Š': 151,
	'T': 84,
	'Þ': 222,
	'U': 85,
	'Ú': 218,
	'Û': 219,
	'Ü': 220,
	'Ù': 217,
	'V': 86,
	'W': 87,
	'X': 88,
	'Y': 89,
	'Ý': 221,
	'Ÿ': 152,
	'Z': 90,
	'Ž': 153,
	'a': 97,
	'á': 225,
	'â': 226,
	// acute ' ́':180,
	'ä':  228,
	'æ':  230,
	'à':  224,
	'&':  38,
	'å':  229,
	'^':  94,
	'~':  126,
	'*':  42,
	'@':  64,
	'ã':  227,
	'b':  98,
	'\\': 92,
	'|':  124,
	'{':  123,
	'}':  125,
	'[':  91,
	']':  93,
	// breve ' ̆':24,
	'¦': 166,
	'•': 128,
	'c': 99,
	'ˇ': 25,
	'ç': 231,
	// cedilla ' ̧':184,
	'¢': 162,
	'ˆ': 26,
	':': 58,
	',': 44,
	'©': 169,
	'¤': 164,
	'd': 100,
	'†': 129,
	'‡': 130,
	'°': 176,
	// dieresis ' ̈':168,
	'÷': 247,
	'$': 36,
	// dotaccent ' ̇':27,
	'ı':  154,
	'e':  101,
	'é':  233,
	'ê':  234,
	'ë':  235,
	'è':  232,
	'8':  56,
	8230: 131,
	'—':  132,
	'–':  133,
	'=':  61,
	'ð':  240,
	'!':  33,
	'¡':  161,
	'f':  102,
	// fi:147,
	'5': 53,
	// fl:148,
	'ƒ': 134,
	'4': 52,
	'⁄': 135,
	'g': 103,
	'ß': 223,
	'`': 96,
	'>': 62,
	'«': 171,
	'»': 187,
	'‹': 136,
	'›': 137,
	'h': 104,
	// hungarumlaut:28,
	'-': 45,
	'i': 105,
	'í': 237,
	'î': 238,
	'ï': 239,
	'ì': 236,
	'j': 106,
	'k': 107,
	'l': 108,
	'<': 60,
	'¬': 172,
	'ł': 155,
	'm': 109,
	// macron ' ̄':175,
	'−': 138,
	'μ': 181,
	'×': 215,
	'n': 110,
	'9': 57,
	'ñ': 241,
	'#': 35,
	'o': 111,
	'ó': 243,
	'ô': 244,
	'ö': 246,
	'œ': 156,
	// ogonek ' ̨':29,
	'ò': 242,
	'1': 49,
	189: 189,
	188: 188,
	// superscript 1 '1':185,
	170:  170,
	186:  186,
	'ø':  248,
	'õ':  245,
	'p':  112,
	'¶':  182,
	'(':  40,
	')':  41,
	'%':  37,
	'.':  46,
	'·':  183,
	'‰':  139,
	'+':  43,
	'±':  177,
	'q':  113,
	'?':  63,
	'¿':  191,
	'"':  34,
	'„':  140,
	'“':  141,
	'”':  142,
	'‘':  143,
	'’':  144,
	'‚':  145,
	'\'': 39,
	'r':  114,
	'®':  174,
	// ring ' ̊':30,
	's': 115,
	'š': 157,
	'§': 167,
	';': 59,
	'7': 55,
	'6': 54,
	'/': 47,
	' ': 32,
	'£': 163,
	't': 116,
	'þ': 254,
	'3': 51,
	190: 190,
	179: 179,
	// tilde :31,
	8482: 146,
	'2':  50,
	178:  178,
	'u':  117,
	'ú':  250,
	'û':  251,
	'ü':  252,
	'ù':  249,
	'_':  95,
	'v':  118,
	'w':  119,
	'x':  120,
	'y':  121,
	'ý':  253,
	'ÿ':  255,
	'¥':  165,
	'z':  122,
	'ž':  158,
	'0':  48,
}

var mapSymbolEncoding = map[rune]byte{
	// TODO: build map from reference
}

var mapZapfDingbatsEncoding = map[rune]byte{
	' ': 32,
	'✁': 33,
	'✂': 34,
	'✃': 35,
	'✄': 36,
	'☎': 37,
	'✆': 38,
	'✇': 39,
	'✈': 40,
	'✉': 41,
	'☛': 42,
	'☞': 43,
	'✌': 44,
	'✍': 45,
	'✎': 46,
	'✏': 47,
	'✐': 48,
	'✑': 49,
	'✒': 50,
	'✓': 51,
	'✔': 52,
	'✕': 53,
	'✖': 54,
	'✗': 55,
	'✘': 56,
	'✙': 57,
	'✚': 58,
	'✛': 59,
	'✜': 60,
	'✝': 61,
	'✞': 62,
	'✟': 63,
	'✠': 64,
	'✡': 65,
	'✢': 66,
	'✣': 67,
	'✤': 68,
	'✥': 69,
	'✦': 70,
	'✧': 71,
	'★': 72,
	'✩': 73,
	'✪': 74,
	'✫': 75,
	'✬': 76,
	'✭': 77,
	'✮': 78,
	'✯': 79,
	'✰': 80,
	'✱': 81,
	'✲': 82,
	'✳': 83,
	'✴': 84,
	'✵': 85,
	'✶': 86,
	'✷': 87,
	'✸': 88,
	'✹': 89,
	'✺': 90,
	'✻': 91,
	'✼': 92,
	'✽': 93,
	'✾': 94,
	'✿': 95,
	'❀': 96,
	'❁': 97,
	'❂': 98,
	'❃': 99,
	'❄': 100,
	'❅': 101,
	'❆': 102,
	'❇': 103,
	'❈': 104,
	'❉': 105,
	'❊': 106,
	'❋': 107,
	'●': 108,
	'❍': 109,
	'■': 110,
	'❏': 111,
	'❐': 112,
	'❑': 113,
	'❒': 114,
	'▲': 115,
	'▼': 116,
	'◆': 117,
	'❖': 118,
	'◗': 119,
	'❘': 120,
	'❙': 121,
	'❚': 122,
	'❛': 123,
	'❜': 124,
	'❝': 125,
	'❞': 126,
	'❡': 161,
	'❢': 162,
	'❣': 163,
	'❤': 164,
	'❥': 165,
	'❦': 166,
	'❧': 167,
	'♣': 168,
	'♦': 169,
	'♥': 170,
	'♠': 171,
	//'1':172,
	//'2':173,
	//'3':174,
	//'4':175,
	//'5':176,
	//'6':177,
	//'7':178,
	//'8':179,
	//'9':180,
	//'10':181,
	'❶': 182,
	'❷': 183,
	'❸': 184,
	'❹': 185,
	'❺': 186,
	'❻': 187,
	'❼': 188,
	'❽': 189,
	'❾': 190,
	'❿': 191,
	'➀': 192,
	'➁': 193,
	'➂': 194,
	'➃': 195,
	'➄': 196,
	'➅': 197,
	'➆': 198,
	'➇': 199,
	'➈': 200,
	'➉': 201,
	'➊': 202,
	'➋': 203,
	'➌': 204,
	'➍': 205,
	'➎': 206,
	'➏': 207,
	'➐': 208,
	'➑': 209,
	'➒': 210,
	'➓': 211,
	'➔': 212,
	'→': 213,
	'↔': 214,
	'↕': 215,
	'➘': 216,
	'➙': 217,
	'➚': 218,
	'➛': 219,
	'➜': 220,
	'➝': 221,
	'➞': 222,
	'➟': 223,
	'➠': 224,
	'➡': 225,
	'➢': 226,
	'➣': 227,
	'➤': 228,
	'➥': 229,
	'➦': 230,
	'➧': 231,
	'➨': 232,
	'➩': 233,
	'➪': 234,
	'➫': 235,
	'➬': 236,
	'➭': 237,
	'➮': 238,
	'➯': 239,
	'➱': 241,
	'➲': 242,
	'➳': 243,
	'➴': 244,
	'➵': 245,
	'➶': 246,
	'➷': 247,
	'➸': 248,
	'➹': 249,
	'➺': 250,
	'➻': 251,
	'➼': 252,
	'➽': 253,
	'➾': 254,
}
